package com.robert_franz.serialize;

import org.junit.Test;

import java.io.*;

/**
 * User: Robert Franz
 * Date: 22.11.13
 * Time: 21:06
 */
public class JavaSerializationTest
{
	@Test
	public void performance() throws ClassNotFoundException, IOException
	{
		long n = 1000_000;
		Testobject testobject = new Testobject();
		testobject.a = "abc";
		testobject.b = 10;
		testobject.c = 100;

		long start = System.currentTimeMillis();
		for (int i = 0; i < n; i++)
		{
			byte[] array = serialize(testobject);
			deserialize(array);
		}
		long end = System.currentTimeMillis();
		System.out.println("Java:" + (end - start) + "ms");

	}

	@Test
	public void size() throws IOException
	{
		Testobject testobject = new Testobject();
		testobject.a = "abc";
		testobject.b = 10;
		testobject.c = 100;
		byte[] array = serialize(testobject);
		System.out.println(array.length);
	}

	public byte[] serialize(Object o) throws IOException
	{
		ByteArrayOutputStream baos = new ByteArrayOutputStream();
		ObjectOutputStream oos = new ObjectOutputStream(baos);

		oos.writeObject(o);
		oos.close();
		baos.close();

		return baos.toByteArray();
	}

	public Object deserialize(byte[] a) throws IOException, ClassNotFoundException
	{
		Object o;
		ByteArrayInputStream bais = new ByteArrayInputStream(a);
		ObjectInputStream ois = new ObjectInputStream(bais);
		o = ois.readObject();

		ois.close();
		bais.close();
		return o;
	}
}
