package com.robert_franz.serialize;

import org.junit.Test;

import java.io.*;

/**
 * User: Robert Franz
 * Date: 23.11.13
 * Time: 09:57
 */
public class ProtobufSerializationTest
{
	@Test
	public void performance() throws ClassNotFoundException, IOException
	{
		long n = 1000_000;
		Testobject testobject = new Testobject();
		testobject.a = "abc";
		testobject.b = 10;
		testobject.c = 100;

		long start = System.currentTimeMillis();
		for (int i = 0; i < n; i++)
		{
			byte[] array = serialize(testobject);
			deserialize(array);
		}
		long end = System.currentTimeMillis();
		System.out.println("Protobuf:" + (end - start) + "ms");
	}

	 @Test
	 public void size() throws IOException
	 {
		 Testobject testobject = new Testobject();
		 testobject.a = "abc";
		 testobject.b = 10;
		 testobject.c = 100;
		 byte[] array = serialize(testobject);
		 System.out.println(array.length);
	 }

	public byte[] serialize(Testobject o) throws IOException
	{
		TestobjectProtobuf.Testobject.Builder builder = TestobjectProtobuf.Testobject.newBuilder();
		builder.setA(o.getA());
		builder.setB(o.getB());
		builder.setC(o.getC());

		return builder.build().toByteArray();
	}

	public Testobject deserialize(byte[] a) throws IOException, ClassNotFoundException
	{
		TestobjectProtobuf.Testobject protobuf = TestobjectProtobuf.Testobject.parseFrom(a);
		Testobject testobject = new Testobject();
		testobject.setA(protobuf.getA());
		testobject.setB(protobuf.getB());
		testobject.setC(protobuf.getC());
		return testobject;
	}
}
